# wifi.radio.&lt;name&gt; Schema

```
https://www.iopsys.eu/wifi.radio.json
```

WiFi Radio Object

| Custom Properties | Additional Properties |
| ----------------- | --------------------- |
| Forbidden         | Forbidden             |

# wifi.radio.&lt;name&gt;

| List of Methods             |
| --------------------------- |
| [autochannel](#autochannel) | Method | wifi.radio.&lt;name&gt; (this schema) |
| [get](#get)                 | Method | wifi.radio.&lt;name&gt; (this schema) |
| [scan](#scan)               | Method | wifi.radio.&lt;name&gt; (this schema) |
| [scanresults](#scanresults) | Method | wifi.radio.&lt;name&gt; (this schema) |
| [stats](#stats)             | Method | wifi.radio.&lt;name&gt; (this schema) |
| [status](#status)           | Method | wifi.radio.&lt;name&gt; (this schema) |

## autochannel

`autochannel`

- type: `Method`

### autochannel Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property   | Type    | Required |
| ---------- | ------- | -------- |
| `algo`     | integer | Optional |
| `interval` | integer | Optional |
| `scans`    | integer | Optional |

#### algo

`algo`

- is optional
- type: `integer`

##### algo Type

`integer`

#### interval

`interval`

- is optional
- type: `integer`

##### interval Type

`integer`

#### scans

`scans`

- is optional
- type: `integer`

##### scans Type

`integer`

### Ubus CLI Example

```
ubus call wifi.radio.<name> autochannel {"interval":-3947445,"algo":-79632421,"scans":-97118460}
```

### JSONRPC Example

```json
{
  "jsonrpc": "2.0",
  "id": 0,
  "method": "call",
  "params": [
    "<SID>",
    "wifi.radio.<name>",
    "autochannel",
    { "interval": -3947445, "algo": -79632421, "scans": -97118460 }
  ]
}
```

#### output

##### wifi.radio.autochannel

Auto channel selection

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property      | Type    | Required     |
| ------------- | ------- | ------------ |
| `code`        | integer | **Required** |
| `new_channel` | oneOf   | **Required** |
| `status`      | string  | **Required** |

#### code

`code`

- is **required**
- type: `integer`

##### code Type

`integer`

#### new_channel

`new_channel`

- is **required**
- type: complex

##### new_channel Type

**One** of the following _conditions_ need to be fulfilled.

#### Condition 1

`integer`

- minimum value: `1`
- maximum value: `14`

#### Condition 2

`integer`

- minimum value: `32`
- maximum value: `200`

#### status

`status`

- is **required**
- type: `string`

##### status Type

`string`

### Output Example

```json
{ "code": -21368995, "new_channel": 139, "status": "quis se" }
```

## get

`get`

- type: `Method`

### get Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `param`  | string | Optional |

#### param

`param`

- is optional
- type: `string`

##### param Type

`string`

### Ubus CLI Example

```
ubus call wifi.radio.<name> get {"param":"sunt"}
```

### JSONRPC Example

```json
{ "jsonrpc": "2.0", "id": 0, "method": "call", "params": ["<SID>", "wifi.radio.<name>", "get", { "param": "sunt" }] }
```

#### output

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property | Type    | Required |
| -------- | ------- | -------- |
| `status` | integer | Optional |
| `values` | integer | Optional |

#### status

`status`

- is optional
- type: `integer`

##### status Type

`integer`

#### values

`values`

- is optional
- type: `integer`

##### values Type

`integer`

### Output Example

```json
{ "status": -47928223, "values": 80011809 }
```

## scan

`scan`

- type: `Method`

### scan Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property  | Type   | Required |
| --------- | ------ | -------- |
| `bssid`   | string | Optional |
| `channel` | oneOf  | Optional |
| `ssid`    | string | Optional |

#### bssid

##### MAC Address

`bssid`

- is optional
- type: reference

##### bssid Type

`string`

- minimum length: 17 characters
- maximum length: 17 characters All instances must conform to this regular expression (test examples
  [here](<https://regexr.com/?expression=%5E(%5B0-9a-fA-F%5D%5B0-9a-fA-F%5D%3A)%7B5%7D%5B0-9a-fA-F%5D%5B0-9a-fA-F%5D%24>)):

```regex
^([0-9a-fA-F][0-9a-fA-F]:){5}[0-9a-fA-F][0-9a-fA-F]$
```

#### channel

`channel`

- is optional
- type: complex

##### channel Type

**One** of the following _conditions_ need to be fulfilled.

#### Condition 1

`integer`

- minimum value: `1`
- maximum value: `14`

#### Condition 2

`integer`

- minimum value: `32`
- maximum value: `200`

#### ssid

##### SSID

`ssid`

- is optional
- type: reference

##### ssid Type

`string`

- maximum length: 32 characters

### Ubus CLI Example

```
ubus call wifi.radio.<name> scan {"ssid":"in","bssid":"6B:3B:df:a8:E8:bf","channel":8}
```

### JSONRPC Example

```json
{
  "jsonrpc": "2.0",
  "id": 0,
  "method": "call",
  "params": ["<SID>", "wifi.radio.<name>", "scan", { "ssid": "in", "bssid": "6B:3B:df:a8:E8:bf", "channel": 8 }]
}
```

#### output

Trigger a scan

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property | Type | Required |
| -------- | ---- | -------- |
| None     | None | None     |

### Output Example

```json
{}
```

## scanresults

`scanresults`

- type: `Method`

### scanresults Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property | Type | Required |
| -------- | ---- | -------- |
| None     | None | None     |

### Ubus CLI Example

```
ubus call wifi.radio.<name> scanresults {}
```

### JSONRPC Example

```json
{ "jsonrpc": "2.0", "id": 0, "method": "call", "params": ["<SID>", "wifi.radio.<name>", "scanresults", {}] }
```

#### output

Show scan results

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property | Type | Required |
| -------- | ---- | -------- |
| None     | None | None     |

### Output Example

```json
{}
```

## stats

`stats`

- type: `Method`

### stats Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property | Type | Required |
| -------- | ---- | -------- |
| None     | None | None     |

### Ubus CLI Example

```
ubus call wifi.radio.<name> stats {}
```

### JSONRPC Example

```json
{ "jsonrpc": "2.0", "id": 0, "method": "call", "params": ["<SID>", "wifi.radio.<name>", "stats", {}] }
```

#### output

##### wifi.radio.iface

Radio statistics

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property               | Type    | Required     |
| ---------------------- | ------- | ------------ |
| `rx_bytes`             | integer | **Required** |
| `rx_dropped_packets`   | integer | **Required** |
| `rx_error_packets`     | integer | **Required** |
| `rx_fcs_error_packets` | integer | **Required** |
| `rx_packets`           | integer | **Required** |
| `tx_bytes`             | integer | **Required** |
| `tx_dropped_packets`   | integer | **Required** |
| `tx_error_packets`     | integer | **Required** |
| `tx_packets`           | integer | **Required** |

#### rx_bytes

`rx_bytes`

- is **required**
- type: reference

##### rx_bytes Type

`integer`

- minimum value: `0`

#### rx_dropped_packets

`rx_dropped_packets`

- is **required**
- type: reference

##### rx_dropped_packets Type

`integer`

- minimum value: `0`

#### rx_error_packets

`rx_error_packets`

- is **required**
- type: reference

##### rx_error_packets Type

`integer`

- minimum value: `0`

#### rx_fcs_error_packets

`rx_fcs_error_packets`

- is **required**
- type: reference

##### rx_fcs_error_packets Type

`integer`

- minimum value: `0`

#### rx_packets

`rx_packets`

- is **required**
- type: reference

##### rx_packets Type

`integer`

- minimum value: `0`

#### tx_bytes

`tx_bytes`

- is **required**
- type: reference

##### tx_bytes Type

`integer`

- minimum value: `0`

#### tx_dropped_packets

`tx_dropped_packets`

- is **required**
- type: reference

##### tx_dropped_packets Type

`integer`

- minimum value: `0`

#### tx_error_packets

`tx_error_packets`

- is **required**
- type: reference

##### tx_error_packets Type

`integer`

- minimum value: `0`

#### tx_packets

`tx_packets`

- is **required**
- type: reference

##### tx_packets Type

`integer`

- minimum value: `0`

### Output Example

```json
{
  "tx_bytes": 62760043,
  "tx_packets": 39487100,
  "tx_error_packets": 4680682,
  "tx_dropped_packets": 45656204,
  "rx_bytes": 4906712,
  "rx_packets": 27902438,
  "rx_error_packets": 94647148,
  "rx_dropped_packets": 95313119,
  "rx_fcs_error_packets": 55108084
}
```

## status

`status`

- type: `Method`

### status Type

`object` with following properties:

| Property | Type   | Required |
| -------- | ------ | -------- |
| `input`  | object | Optional |
| `output` | object | Optional |

#### input

`input`

- is optional
- type: `object`

##### input Type

`object` with following properties:

| Property | Type | Required |
| -------- | ---- | -------- |
| None     | None | None     |

### Ubus CLI Example

```
ubus call wifi.radio.<name> status {}
```

### JSONRPC Example

```json
{ "jsonrpc": "2.0", "id": 0, "method": "call", "params": ["<SID>", "wifi.radio.<name>", "status", {}] }
```

#### output

##### wifi.radio.iface

Radio status

`output`

- is optional
- type: `object`

##### output Type

`object` with following properties:

| Property            | Type    | Required     | Default |
| ------------------- | ------- | ------------ | ------- |
| `band`              | string  | **Required** |         |
| `beacon_int`        | integer | **Required** | `100`   |
| `dtim_period`       | integer | **Required** | `1`     |
| `frag_threshold`    | integer | **Required** | `2346`  |
| `isup`              | boolean | **Required** |         |
| `long_retry_limit`  | integer | **Required** |         |
| `maxrate`           | integer | **Required** |         |
| `noise`             | integer | **Required** |         |
| `radio`             | string  | **Required** |         |
| `rts_threshold`     | integer | **Required** | `2347`  |
| `short_retry_limit` | integer | **Required** |         |

#### band

##### WiFi Band

`band`

- is **required**
- type: reference

##### band Type

`string`

The value of this property **must** be equal to one of the [known values below](#status-known-values).

##### band Known Values

| Value |
| ----- |
| 2GHz  |
| 5GHz  |

#### beacon_int

`beacon_int`

- is **required**
- type: `integer`
- default: `100`

##### beacon_int Type

`integer`

- minimum value: `1`
- maximum value: `65535`

#### dtim_period

`dtim_period`

- is **required**
- type: `integer`
- default: `1`

##### dtim_period Type

`integer`

- minimum value: `1`
- maximum value: `255`

#### frag_threshold

`frag_threshold`

- is **required**
- type: `integer`
- default: `2346`

##### frag_threshold Type

`integer`

- minimum value: `256`
- maximum value: `65535`

#### isup

`isup`

- is **required**
- type: `boolean`

##### isup Type

`boolean`

#### long_retry_limit

`long_retry_limit`

- is **required**
- type: `integer`

##### long_retry_limit Type

`integer`

- minimum value: `1`
- maximum value: `255`

#### maxrate

`maxrate`

- is **required**
- type: `integer`

##### maxrate Type

`integer`

- minimum value: `0`

#### noise

##### Noise

`noise`

- is **required**
- type: reference

##### noise Type

`integer`

- minimum value: `-127`
- maximum value: `0`

#### radio

##### Interface

`radio`

- is **required**
- type: reference

##### radio Type

`string`

- minimum length: 1 characters
- maximum length: 16 characters

#### rts_threshold

`rts_threshold`

- is **required**
- type: `integer`
- default: `2347`

##### rts_threshold Type

`integer`

- minimum value: `0`
- maximum value: `65535`

#### short_retry_limit

`short_retry_limit`

- is **required**
- type: `integer`

##### short_retry_limit Type

`integer`

- minimum value: `1`
- maximum value: `255`

### Output Example

```json
{
  "radio": "eiusmod sint",
  "isup": true,
  "band": "5GHz",
  "noise": -80,
  "maxrate": 69768222,
  "beacon_int": 13308,
  "dtim_period": 19,
  "short_retry_limit": 220,
  "long_retry_limit": 139,
  "frag_threshold": 4365,
  "rts_threshold": 17136,
  "channel": false,
  "bandwidth": "ex in Lorem pariatur velit"
}
```
